Index: contrib/testsuite-management/arm-grtev2-linux-gnueabi.xfail
===================================================================
--- contrib/testsuite-management/arm-grtev2-linux-gnueabi.xfail	(revision 0)
+++ contrib/testsuite-management/arm-grtev2-linux-gnueabi.xfail	(revision 0)
@@ -0,0 +1,126 @@
+# Failures in ./gcc/testsuite/gcc/gcc.sum:
+# *** gcc:
+FAIL: gcc.c-torture/compile/920928-2.c  -Os  (internal compiler error)
+FAIL: gcc.c-torture/compile/920928-2.c  -Os  (test for excess errors)
+FAIL: gcc.dg/builtin-apply2.c execution test
+FAIL: gcc.dg/cproj-fails-with-broken-glibc.c execution test
+FAIL: gcc.dg/di-longlong64-sync-1.c (test for excess errors)
+UNRESOLVED: gcc.dg/di-longlong64-sync-1.c compilation failed to produce executable
+FAIL: gcc.dg/di-sync-multithread.c execution test
+FAIL: gcc.dg/pr49994-3.c (test for excess errors)
+FAIL: gcc.dg/tls/pr42894.c (test for excess errors)
+FAIL: gcc.dg/torture/stackalign/builtin-apply-2.c  -O0  execution test
+FAIL: gcc.dg/torture/stackalign/builtin-apply-2.c  -O0  execution test
+FAIL: gcc.dg/torture/stackalign/builtin-apply-2.c  -O1  execution test
+FAIL: gcc.dg/torture/stackalign/builtin-apply-2.c  -Os  execution test
+
+# There are flaky when running on QEMU
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O0  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O1  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O2  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O3 -fomit-frame-pointer  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O3 -g  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -Os  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O0  -fpic  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O1  -fpic  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O2  -fpic  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O3 -fomit-frame-pointer  -fpic  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O3 -g  -fpic  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -Os  -fpic  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O0  -fPIC  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O1  -fPIC  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O2  -fPIC  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O3 -fomit-frame-pointer  -fPIC  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O3 -g  -fPIC  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -Os  -fPIC  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O0  -pie -fpie  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O1  -pie -fpie  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O2  -pie -fpie  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O3 -fomit-frame-pointer  -pie -fpie  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O3 -g  -pie -fpie  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -Os  -pie -fpie  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O0  -pie -fPIE  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O1  -pie -fPIE  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O2  -pie -fPIE  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O3 -fomit-frame-pointer  -pie -fPIE  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O3 -g  -pie -fPIE  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -Os  -pie -fPIE  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O2 -flto -fno-use-linker-plugin -flto-partition=none  execution test
+flaky | FAIL: gcc.dg/torture/tls/tls-test.c  -O2 -flto -fuse-linker-plugin -fno-fat-lto-objects  execution test
+
+FAIL: gcc.dg/tree-ssa/sra-12.c scan-tree-dump-times release_ssa "l;" 0
+FAIL: gcc.dg/vect/vect-104.c scan-tree-dump-times vect "possible dependence between data-refs" 1
+FAIL: gcc.dg/vect/vect-multitypes-11.c scan-tree-dump-times vect "vectorized 1 loops" 1
+FAIL: gcc.dg/vect/vect-multitypes-12.c scan-tree-dump-times vect "vectorized 1 loops" 1
+FAIL: gcc.dg/vect/vect-outer-1-big-array.c scan-tree-dump-times vect "strided access in outer loop" 1
+FAIL: gcc.dg/vect/vect-outer-1.c scan-tree-dump-times vect "strided access in outer loop" 1
+FAIL: gcc.dg/vect/vect-outer-1a-big-array.c scan-tree-dump-times vect "strided access in outer loop" 1
+FAIL: gcc.dg/vect/vect-outer-1a.c scan-tree-dump-times vect "strided access in outer loop" 1
+FAIL: gcc.dg/vect/vect-outer-1b-big-array.c scan-tree-dump-times vect "strided access in outer loop" 1
+FAIL: gcc.dg/vect/vect-outer-1b.c scan-tree-dump-times vect "strided access in outer loop" 1
+FAIL: gcc.dg/vect/vect-outer-2b.c scan-tree-dump-times vect "strided access in outer loop" 1
+FAIL: gcc.dg/vect/vect-outer-3a-big-array.c scan-tree-dump-times vect "step doesn't divide the vector-size" 2
+FAIL: gcc.dg/vect/vect-outer-3a.c scan-tree-dump-times vect "step doesn't divide the vector-size" 2
+FAIL: gcc.dg/vect/vect-outer-3b.c scan-tree-dump-times vect "strided access in outer loop" 2
+FAIL: gcc.dg/vect/vect-reduc-dot-s16b.c scan-tree-dump-times vect "vectorized 1 loops" 0
+FAIL: gcc.dg/vect/vect-reduc-dot-s8b.c scan-tree-dump-times vect "vect_recog_widen_mult_pattern: detected" 1
+FAIL: gcc.dg/vect/vect-reduc-pattern-1a.c scan-tree-dump-times vect "vectorized 1 loops" 0
+FAIL: gcc.dg/vect/vect-reduc-pattern-1b-big-array.c scan-tree-dump-times vect "vectorized 1 loops" 0
+FAIL: gcc.dg/vect/vect-reduc-pattern-1b.c scan-tree-dump-times vect "vectorized 1 loops" 0
+FAIL: gcc.dg/vect/vect-reduc-pattern-1c-big-array.c scan-tree-dump-times vect "vectorized 1 loops" 0
+FAIL: gcc.dg/vect/vect-reduc-pattern-1c.c scan-tree-dump-times vect "vectorized 1 loops" 0
+FAIL: gcc.dg/vect/vect-reduc-pattern-2a.c scan-tree-dump-times vect "vectorized 1 loops" 0
+FAIL: gcc.dg/vect/vect-reduc-pattern-2b-big-array.c scan-tree-dump-times vect "vectorized 1 loops" 0
+FAIL: gcc.dg/vect/vect-reduc-pattern-2b.c scan-tree-dump-times vect "vectorized 1 loops" 0
+FAIL: gcc.dg/vect/slp-perm-8.c scan-tree-dump-times vect "vectorized 1 loops" 2
+XPASS: gcc.dg/vect/slp-reduc-3.c scan-tree-dump-times vect "vectorizing stmts using SLP" 1
+FAIL: gcc.dg/vect/vect-104.c -flto scan-tree-dump-times vect "possible dependence between data-refs" 1
+FAIL: gcc.dg/vect/vect-multitypes-11.c -flto scan-tree-dump-times vect "vectorized 1 loops" 1
+FAIL: gcc.dg/vect/vect-multitypes-12.c -flto scan-tree-dump-times vect "vectorized 1 loops" 1
+FAIL: gcc.dg/vect/vect-outer-1-big-array.c -flto scan-tree-dump-times vect "strided access in outer loop" 1
+FAIL: gcc.dg/vect/vect-outer-1.c -flto scan-tree-dump-times vect "strided access in outer loop" 1
+FAIL: gcc.dg/vect/vect-outer-1a-big-array.c -flto scan-tree-dump-times vect "strided access in outer loop" 1
+FAIL: gcc.dg/vect/vect-outer-1a.c -flto scan-tree-dump-times vect "strided access in outer loop" 1
+FAIL: gcc.dg/vect/vect-outer-1b-big-array.c -flto scan-tree-dump-times vect "strided access in outer loop" 1
+FAIL: gcc.dg/vect/vect-outer-1b.c -flto scan-tree-dump-times vect "strided access in outer loop" 1
+FAIL: gcc.dg/vect/vect-outer-2b.c -flto scan-tree-dump-times vect "strided access in outer loop" 1
+FAIL: gcc.dg/vect/vect-outer-3a-big-array.c -flto scan-tree-dump-times vect "step doesn't divide the vector-size" 2
+FAIL: gcc.dg/vect/vect-outer-3a.c -flto scan-tree-dump-times vect "step doesn't divide the vector-size" 2
+FAIL: gcc.dg/vect/vect-outer-3b.c -flto scan-tree-dump-times vect "strided access in outer loop" 2
+FAIL: gcc.dg/vect/vect-reduc-dot-s16b.c -flto scan-tree-dump-times vect "vectorized 1 loops" 0
+FAIL: gcc.dg/vect/vect-reduc-dot-s8b.c -flto scan-tree-dump-times vect "vect_recog_widen_mult_pattern: detected" 1
+FAIL: gcc.dg/vect/vect-reduc-pattern-1a.c -flto scan-tree-dump-times vect "vectorized 1 loops" 0
+FAIL: gcc.dg/vect/vect-reduc-pattern-1b-big-array.c -flto scan-tree-dump-times vect "vectorized 1 loops" 0
+FAIL: gcc.dg/vect/vect-reduc-pattern-1b.c -flto scan-tree-dump-times vect "vectorized 1 loops" 0
+FAIL: gcc.dg/vect/vect-reduc-pattern-1c-big-array.c -flto scan-tree-dump-times vect "vectorized 1 loops" 0
+FAIL: gcc.dg/vect/vect-reduc-pattern-1c.c -flto scan-tree-dump-times vect "vectorized 1 loops" 0
+FAIL: gcc.dg/vect/vect-reduc-pattern-2a.c -flto scan-tree-dump-times vect "vectorized 1 loops" 0
+FAIL: gcc.dg/vect/vect-reduc-pattern-2b-big-array.c -flto scan-tree-dump-times vect "vectorized 1 loops" 0
+FAIL: gcc.dg/vect/vect-reduc-pattern-2b.c -flto scan-tree-dump-times vect "vectorized 1 loops" 0
+FAIL: gcc.dg/vect/slp-perm-8.c -flto scan-tree-dump-times vect "vectorized 1 loops" 2
+XPASS: gcc.dg/vect/slp-reduc-3.c -flto scan-tree-dump-times vect "vectorizing stmts using SLP" 1
+FAIL: gcc.dg/vect/no-vfa-vect-101.c scan-tree-dump-times vect "can't determine dependence" 1
+FAIL: gcc.dg/vect/no-vfa-vect-102.c scan-tree-dump-times vect "possible dependence between data-refs" 1
+FAIL: gcc.dg/vect/no-vfa-vect-102a.c scan-tree-dump-times vect "possible dependence between data-refs" 1
+FAIL: gcc.dg/vect/no-vfa-vect-37.c scan-tree-dump-times vect "can't determine dependence" 2
+FAIL: gcc.dg/vect/no-vfa-vect-79.c scan-tree-dump-times vect "can't determine dependence" 1
+FAIL: gcc.dg/vect/wrapv-vect-reduc-pattern-2c.c scan-tree-dump-times vect "vectorized 1 loops" 0
+XPASS: gcc.dg/vect/no-scevccp-outer-16.c scan-tree-dump-times vect "OUTER LOOP VECTORIZED." 1
+XPASS: gcc.dg/vect/no-scevccp-outer-17.c scan-tree-dump-times vect "OUTER LOOP VECTORIZED." 1
+XPASS: gcc.dg/vect/no-scevccp-outer-19.c scan-tree-dump-times vect "OUTER LOOP VECTORIZED." 1
+XPASS: gcc.dg/vect/no-scevccp-outer-21.c scan-tree-dump-times vect "OUTER LOOP VECTORIZED." 1
+FAIL: gcc.target/arm/pr42575.c scan-assembler-not mov
+FAIL: gcc.target/arm/thumb-ltu.c (test for excess errors)
+UNRESOLVED: gcc.target/arm/thumb-ltu.c scan-assembler-not uxtb
+FAIL: gcc.target/arm/tlscall.c (test for excess errors)
+
+# Failures in ./gcc/testsuite/gfortran/gfortran.sum:
+# *** gfortran:
+FAIL: gfortran.dg/vect/pr19049.f90  -O  scan-tree-dump-times vect "complicated access pattern" 1
+FAIL: gfortran.dg/vect/pr32380.f  -O  scan-tree-dump-times vect "vectorized 7 loops" 1
+FAIL: gfortran.dg/vect/fast-math-pr38968.f90 execution test
+
+# Failures in ./gcc/testsuite/g++/g++.sum:
+# *** g++:
+FAIL: g++.dg/abi/forced.C -std=gnu++98 execution test
+FAIL: g++.dg/abi/forced.C -std=gnu++11 execution test